function Ped02300_preco_base_Controller(templateManager, ScreenService, General, Ped02300PrecoBaseServices, restEngine, MessageService, localStorageEngine) {
    var checkedFields = [];
    var checkedFieldsReajuste = [];
    
    this.retornaUnidadeLogada = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return localStorageEngine.download("ped#/crud/filial", filter);
    };
    
    this.savePrecoBase = function(args){
        
        General.saveCrud(args.owner.widget).then(function(success){
            General.changeWidgetAcessibility(args.owner.widget.widgets,true);
        });
        
    };
    
    this.saveListaItemPreBase = function(widget){

        if(widget.currentRow.VRITEPREBASE == '0.00' || widget.currentRow.VRITEPREBASE == '0'){
            ScreenService.showMessage("O preço do produto deve ser diferente de 0.00"); 
        }else{
            Ped02300PrecoBaseServices.retornaOperadorLogado().then(function(operadorLogado){
                widget.currentRow.CDOPERATZIPB =  operadorLogado[0].CDOPERADOR;
                General.saveCrud(widget);
            });   
        }
        
        
    };
    
    this.setDataSourceFilterPromocao = function(widget){
        widget.dataSourceFilter = [
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widget.getParent().getParent().getParent().currentRow.CDPRECOBASE
            },
            {
                name: "P_DTINIVALIPB",
                operator: "=",
                value: widget.getParent().currentRow.DTINIVALIPB
            },
            {
                name: "P_CDPRODUTO",
                operator: "=",
                value: widget.getParent().currentRow.CDPRODUTO
            }
        ];
        widget.reload();
    };
    
    this.getNrorg = function(){
        return templateManager.container.getWidget('promocao').currentRow.NRORG;
    };
    
    this.salvarPromoPrBase = function(widget){
        if(widget.isValid()){
            this.setPreco(widget);
            var dadosPromoPrBase;
            var row = widget.currentRow;
                if(widget.currentRow.__is_new){
                    Ped02300PrecoBaseServices.newCode(row).then(function(success){
                        dadosPromoPrBase = {
                            "__createdLocal": true,
                            "__index": 4,
                            "__isSelected": false,
                            "__is_new": true,
                            "__notSelectable": false,
                            "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                            "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                            "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                            "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                            "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                            "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                            "DTINIPROMO": widget.currentRow.DTINIPROMO,
                            "DTFINPROMO": widget.currentRow.DTFINPROMO,
                            "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                            "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                            "NRORG": this.getNrorg(),
                            "CDPROMOCAO": success.dataset.data[0]
                        };
                        Ped02300PrecoBaseServices.setPromoPrBase(dadosPromoPrBase).then(function(){
                            ScreenService.closeSwipe();
                            widget.getField('VRPERBASEPROMO').readOnly = true;
                            widget.getField('VRTOTALPROMO').readOnly = false;
                            widget.reload();
                        }.bind(this), function (error) {
                            ScreenService.showMessage(error.error);
                        });  
                    }.bind(this), function(error){
                        ScreenService.showMessage(error);    
                    });
                } else {
                    dadosPromoPrBase = {
                        "__index": 2,
                        "__isSelected": false,
                        "__is_new": false,
                        "__notSelectable": false,
                        "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                        "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                        "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                        "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                        "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                        "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                        "DTINIPROMO": widget.currentRow.DTINIPROMO,
                        "DTFINPROMO": widget.currentRow.DTFINPROMO,
                        "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                        "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                        "NRORG": this.getNrorg(),
                        "CDPROMOCAO": widget.currentRow.CDPROMOCAO
                    };
                    Ped02300PrecoBaseServices.setPromoPrBase(dadosPromoPrBase).then(function(){
                        ScreenService.closeSwipe();
                        widget.getField('VRPERBASEPROMO').readOnly = true;
                        widget.getField('VRTOTALPROMO').readOnly = false;
                        widget.reload();
                    }.bind(this), function (error) {
                        ScreenService.showMessage(error.error);
                    });    
                }
        }
    };
    
    this.editar = function(widget){
        
        if(widget.currentRow.VRITEPREBASE == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDOPERATZIPB = getLocalVar("ERP_CDOPERADOR");
            widget.currentRow.DTHRATZIPB = moment().format('DD/MM/YYYY');
            widget.currentRow.CDPRECOBASE = General.getFieldValue('CDPRECOBASE', 'precoBase');
        }
        General.edit(widget);
        
    };
    

    this.prodIni = function(widget){
        
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        widget.reload();
        this.prodFin(widget);
    };
    
    this.prodFin = function(){
        var widget = templateManager.container.getWidget('itemPreBase');
        var row = widget.currentRow;
        var widgetLista = widget.container.getWidget('listaItemPreBase');
 
        widgetLista.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                value: widgetLista.getParent().getParent().currentRow.NRORG
            },
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widgetLista.getParent().getParent().currentRow.CDPRECOBASE
            }
        ];
        if(row.NMPRODFIN){
            if(row.P_CDPRODUTOINI > row.P_CDPRODUTOFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        if(row.IDPRODATIVPR== 'S' ||row.IDPRODATIVPR== 'N'){
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_IDPRODATIVPR",
                    operator: "=",
                    value: row.IDPRODATIVPR
                }
            );
        }else{
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_TIDPRODATIVPR",
                    operator: "=",
                    value: row.IDPRODATIVPR
                }
            );
        }
        if(row.DATAVIGENTE == 'P'){
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_DATAVIGENTE",
                    operator: "=",
                    value: moment().format('L')
                }
            );
        }else{
            widgetLista.dataSourceFilter.push(
                {
                    name: "P_TDATAVIGENTE",
                    operator: "=",
                    value: "T"
                }
            );
        }
        widgetLista.reload();
    };
    
    this.setFieldValor = function(args){
        var row = args.owner.field.widget.currentRow;
        if(row.IDTIPOPROMO != "V"){
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = false;
        } else {
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = true;
        }
    };
    
    this.setSelects = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.IDPRODATIVPR = 'S';
        widget.getField('IDPRODATIVPR').setValue('S');
        widget.currentRow.DATAVIGENTE = 'P';
        widget.getField('DATAVIGENTE').setValue('P');
        widget.reload();
    };
    
    this.setPreco = function(widget){
        var porcentagem;
        var row = widget.currentRow;
        row.VRITEPREBASE = General.getFieldValue('VRITEPREBASE','listaItemPreBase');
        if(row.IDTIPOPROMO == "A"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE + porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        } 
        if(row.IDTIPOPROMO == "D"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE - porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        }
    };
    
    this.setView = function(widget){
        if(widget.container.getWidget('listaItemPreBase').getField('VRITEPREBASE').value() == undefined){
            General.changeWidgetAcessibility(widget.widgets,false);
        } else {
            General.changeWidgetAcessibility(widget.widgets,true);
        }
        switch (widget.getParent().getParent().currentRow.IDULTPRECPROMO) {
            case 'S':
                widget.widgets[0].isVisible = true;
                widget.widgets[1].isVisible = false;
                widget.widgets[2].isVisible = true;
                break;
            case 'N':
                widget.widgets[0].isVisible = false;
                widget.widgets[1].isVisible = true;
                widget.widgets[2].isVisible = true;
                break;
        }
        widget.reload();
    };
    
    this.prodIniFator = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFINFATOR').readOnly = !row.NMPRODINIFATOR;
        widget.getField('NMPRODFINFATOR').readOnlyOnEdit = !row.NMPRODINIFATOR;
        this.prodFinFator(widget);
    };
    
    this.prodFinFator = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('produtosFatorAjuste');
        widget.dataSourceFilter = [
            {
                name: "P_CDFATPRECO",
                operator: "=",
                value: General.getFieldValue('CDFATPRECO', 'fator')
            }
        ];
        if(row.NMPRODFINFATOR){
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    
    this.editarFator = function(widget){
        if(widget.currentRow.VRFATPRECO == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDFATPRECO = General.getFieldValue('CDFATPRECO', 'fator');
        }
        General.edit(widget);
    };
    
    this.validaIntervalo = function(widget) {
        restEngine.post("/validaIntervalo",{'requestType': 'DataSet', 'dataset': [widget.currentRow]})
        .then(function (data) {
            widget.reload();
        }).
        catch(function(e){
            ScreenService.showMessage(e.data.error);
            widget.currentRow.QTCONVINIPRB = "";
            widget.currentRow.QTCONVFINPRB = "";
        });
    };
    
    this.validaValor = function(widget){
        if(widget.currentRow.VRPREBASECONV <= 0 || widget.currentRow.VRPREBASECONV == null){
            ScreenService.showMessage("O valor não pode ser menor ou igual a zero.");
        } else { 
            General.saveCrud(widget);
            widget.reload();
        }    
    };
    
    this.preparaExportacao = function(widget){
        checkedFields[0] = widget.getCheckedRows();
        
        var ItemNull = false;
        var ItemCount = 0;
        var ItemNameArray = [];
        var ItemNameString = "";
        
        if(!checkedFields[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFields[0].length; i++){
                if(checkedFields[0][i].CDPRECOBASE == null){
                    ItemNull = true;
                    ItemCount++;
                    ItemNameArray.push(checkedFields[0][i].NMPRODUTO);
                }
            }
            
            if (ItemNull) {
                
                ItemNameString = "'" + ItemNameArray[0] + "'";
                
                for (i = 1; i < ItemNameArray.length; i++) {
                    
                    if(i == ItemNameArray.length-1) {
                        ItemNameString += " e '" + ItemNameArray[i] + "'";
                    } else {
                        ItemNameString += ", '" + ItemNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemNameString + " não possui(em) preço(s).");
                var var_produtoNaoPossuiPreco_msg = "PRODUTO_NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_produtoNaoPossuiPreco_msg,{"PRODUTO": ItemNameString});
                
                return 0;
                
            } else {
                var newWidget = templateManager.container.getWidget("exportItem_popup");
                newWidget.dataSourceFilter = [
                    {
                        "name": "CDPRECOBASE",
                        "operator": "<>",
                        "value": widget.getParent().getParent().currentRow.CDPRECOBASE
                    }
                ];
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                newWidget.reload();
                ScreenService.openPopup(newWidget);
            }
            
            
        }
    };
    
    this.closeExport = function(widget) {
      ScreenService.closePopup();
      widget.isVisible = false;
    };
    
    this.exportPrecos = function(widget){
        checkedFields[1] = widget.getCheckedRows();
        
        restEngine.post("ped_pedidos#/exportarItem",{
            'requestType': 'DataSet', 
            'dataset': [checkedFields]
            
        }).then(function(success) {
            ScreenService.showMessage("Itens importados com sucesso.");
            ScreenService.closePopup();  
        }, function(callback){
            ScreenService.showMessage("Não foi possível exporta os itens selecionados.");
            ScreenService.closePopup();  
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.reajuste = function(widget){
        checkedFieldsReajuste[0] = widget.getCheckedRows();
        
        var ItemReajusteNull = false;
        var ItemReajusteCount = 0;
        var ItemReajusteNameArray = [];
        var ItemReajusteNameString = "";
        
        if(!checkedFieldsReajuste[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFieldsReajuste[0].length; i++){
                if(checkedFieldsReajuste[0][i].CDPRECOBASE == null){
                    ItemReajusteNull = true;
                    ItemReajusteCount++;
                    ItemReajusteNameArray.push(checkedFieldsReajuste[0][i].NMPRODUTO);
                }
            }
            
            if (ItemReajusteNull) {
                
                ItemReajusteNameString = "'" + ItemReajusteNameArray[0] + "'";
                
                for (i = 1; i < ItemReajusteNameArray.length; i++) {
                    
                    if(i == ItemReajusteNameArray.length-1) {
                        ItemReajusteNameString += " e '" + ItemReajusteNameArray[i] + "'";
                    } else {
                        ItemReajusteNameString += ", '" + ItemReajusteNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemReajusteNameString + " não possui(em) preço(s).");
                var var_naoPossuiPreco_msg = "NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_naoPossuiPreco_msg,{"ITEM": ItemReajusteNameString});
                return 0;
                
            } else {
                ScreenService.showMessage("As promoções desse item vão ser apagados após o reajuste");
                var newWidget = templateManager.container.getWidget("reajuste_popup");
                newWidget.isVisible = true;
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                ScreenService.openPopup(newWidget);
            }
            
        }
    };
    
    this.reajustePrecos = function(widget){
        
        if(widget.currentRow.IDTIPOREAJUSTE == null){
            ScreenService.showMessage("Selecione um tipo de reajuste.");
            return 0;
        }
        if(widget.currentRow.VRPERBASEPROMO <= 0){
            ScreenService.showMessage("O valor da porcentagem não pode ser menor ou igual a 0;");
            return 0;
        }
        
        checkedFieldsReajuste[1] = widget.currentRow.VRPERBASEPROMO;
        checkedFieldsReajuste[2] = widget.currentRow.DTFIMVALIPB;
        checkedFieldsReajuste[3] = widget.currentRow.IDTIPOREAJUSTE;
        
        
        
        restEngine.post("/reajusteItem",{'requestType': 'DataSet', 'dataset': [checkedFieldsReajuste]}).then(function() {
            ScreenService.showMessage("Itens reajustado com sucesso.");
            ScreenService.closePopup();
            widget.getParent().reload();
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.saveFatorPreco = function(widget){
        if(widget.currentRow.__is_new == true){    
            Ped02300PrecoBaseServices.saveFatorPreco(widget.currentRow).then(function(sucess){
                ScreenService.goBack();
                widget.reload();
            }, function(error){
                ScreenService.showMessage(error.data.error);
            });
        } else {
            General.saveCrud(widget);
        }
    };
    
    this.newRowDesc = function(widget){
        widget.newRow();
        widget.currentRow.CDPRECOBASE = widget.getParent().getParent().currentRow.CDPRECOBASE;
        widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
    };
    
    this.fieldOnChangePais = function(){
        var widget = templateManager.container.getWidget('desconto_maximo');
        var dadosWidget = templateManager.container.getWidget('desconto_maximo_grid');
        
        if(!widget.getField('NMPAIS').value()) {
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            dadosWidget.isVisible = true;
            dadosWidget.activate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = true;
            });
            dadosWidget.reload();
        }
    };
    
    this.verificaPorcentagem = function(field){
        var valor_porcentagem = parseFloat(field.value().toString().replace(",","."));
        if((valor_porcentagem < 0) || (valor_porcentagem > 100)){
            //ScreenService.showMessage(field.label+" deve ser entre 0 e 100.");
            var var_porcentagem_msg = "PORCENTAGEM_MSG";
            MessageService.showMessageByCode(var_porcentagem_msg,{"FIELD": field.label});
            
            field.clearValue();
        }
    };
    
    this.getLevelByMaskNomeProduto = function(widget){
        var filtro = General.getLevelByMask('CDPICTPROD',1).length;
        
        widget.getField('NMPRODUTO').dataSourceFilter[0] = {
            "name": "CDNVPRODUTO",
            "operator": "=",
            "value": filtro
        };
        
        widget.getField('NMPRODUTO').reload();
    };
    /*global moment*/
    this.verificaValidade = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.__is_new == true){
            var maiorDataFinal;
            var menorDataInicial;
            var preco = widget.currentRow.VRITEPREBASE;
            var filter = [
                {
                    "name": "CDPRODUTO",
                    "operator": "=",
                    "value": widget.currentRow.CDPRODUTO
                },
                {
                  "name": "CDPRECOBASE",
                    "operator": "=",
                    "value": widget.currentRow.CDPRECOBASE  
                }
            ];
    
            General.callRestEngine('ped#/crud/itemprebase', 'FilterData', filter).then(function(callback){
                var validades = callback.dataset.itemprebase;
                validades.forEach(comparaValidade);
                
                function comparaValidade(validade, index){
                    if(index >= 0){
                        maiorDataFinal = moment(validade.DTFIMVALIPB,'DD/MM/YYYY').format('L');
                        menorDataInicial = moment(validade.DTINIVALIPB,'DD/MM/YYYY').format('L') ;
                        
                        menorDataInicial = menorDataInicial.split("/").reverse("").join("/");
                        maiorDataFinal = maiorDataFinal.split("/").reverse("").join("/");
                        
                        //this.validaDatasValidade(maiorDataFinal, menorDataInicial);
                        
                        /* inicio bloco validaDatasValidade */
                        var widget = templateManager.container.getWidget('listaItemPreBase');
            
                        var inicial = moment(widget.getField('DTINIVALIPB').value(),'DD/MM/YYYY').format('L');
                        var final = moment(widget.getField('DTFIMVALIPB').value(), 'DD/MM/YYYY').format('L');
                        
                        inicial = inicial.split("/").reverse("").join("/");
                        final = final.split("/").reverse("").join("/");
                        
                        if (final != "Invalid date"){
                            if(final <= inicial){
                                ScreenService.showMessage("A data final deve ser maior do que a data Inicial.");
                                widget.getField('DTFIMVALIPB').setValue(null);
                                
                            }else if (final >= maiorDataFinal && inicial <= menorDataInicial){
                                ScreenService.showMessage("Não pode haver outras validades contidas dentro das datas selecionadas.");
                                widget.getField('DTFIMVALIPB').setValue(null);
                                
                                    
                            }else if(final >= menorDataInicial  && final <= maiorDataFinal){
                                    ScreenService.showMessage("A data final não pode estar contida outras validades.");
                                    widget.getField('DTFIMVALIPB').setValue(null);
                                
                            }
                        }else if(inicial >= menorDataInicial && inicial <= maiorDataFinal){
                                ScreenService.showMessage("A data inicial não pode estar contida nas outras validades.");
                                widget.getField('DTINIVALIPB').setValue(null);
                            
                        }else if (preco != "" && final == "Invalid date"){
                            if (inicial <= menorDataInicial){
                                ScreenService.showMessage("Existem outras validades já cadastradas no período selecionado.");
                                    widget.getField('DTINIVALIPB').setValue(null);
                                    widget.getField('DTFIMVALIPB').setValue(null);
                                    widget.getField('VRITEPREBASE').setValue("");
                                    
                                }
                        }
                        
                        /* fim bloco validaDatasValidade */
                    }
                }
            }.bind(this));
        }
    };
    
    // início metodos aba de Preço por Cliente
    
    this.novaValidade = function(widget){
        
        var codigo = widget.currentRow.CDARVPROD;
        var nome = widget.currentRow.NMPRODUTO;
        var unidade = widget.currentRow.SGUNIDADE;
        var CDOPERATZIPB =  widget.currentRow.CDOPERATZIPB;
        var CDPRECOBASE =  widget.getParent().getParent().currentRow.CDPRECOBASE;
        var NRORG =  widget.currentRow.NRORG;
        var CDPRODUTO = widget.currentRow.CDPRODUTO;

        widget.newRow();
        widget.currentRow.CDARVPROD = codigo;
        widget.currentRow.NMPRODUTO = nome;
        widget.currentRow.SGUNIDADE = unidade;
        widget.currentRow.CDOPERATZIPB = CDOPERATZIPB;
        widget.currentRow.CDPRECOBASE = CDPRECOBASE;
        widget.currentRow.NRORG = NRORG;
        widget.currentRow.CDPRODUTO = CDPRODUTO;
        widget.currentRow.DTHRATZIPB = moment().format('DD/MM/YYYY');
        widget.reload();
    };
    
    this.editarTabpreclie = function(widget){
        
        if(widget.currentRow.CDCLIENTE == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDCLIENTE = templateManager.container.getWidget('popupFiltroTabpreclie').currentRow.CDCLIENTE;
            // widget.currentRow.CDOPERINCLUSAO = getLocalVar("ERP_CDOPERADOR");
            // widget.currentRow.CDOPERULTATU = getLocalVar("ERP_CDOPERADOR");
            widget.currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY');
            widget.currentRow.DTULTATU = moment().format('DD/MM/YYYY');
        }
        General.edit(widget);
        
    };
    
    this.salvaProduto = function(widget){
        this.validaDataPrecoCliente(widget);
    };
    
    this.validaDataPrecoCliente = function(widget){
        if(widget.currentRow.VRPRECOPROD == '0.00' || widget.currentRow.VRPRECOPROD == '0'){
            ScreenService.showMessage("O preço do produto deve ser diferente de 0.00");
        }else{
            var inicial = moment(widget.getField('DTVALINI').value(),'DD/MM/YYYY').format('L');
            var final = moment(widget.getField('DTVALFIN').value(), 'DD/MM/YYYY').format('L');
                        
            inicial = inicial.split("/").reverse("").join("/");
            final = final.split("/").reverse("").join("/");
            
            if(inicial != "Invalid date" && final != "Invalid date"){
                if(final <= inicial){
                    ScreenService.showMessage("A validade final deve ser maior do que a validade inicial.");
                    widget.currentRow.DTVALINI = '';
                    widget.currentRow.DTVALFIN = '';
                    widget.getField('DTVALFIN').value('');
                    widget.getField('DTVALINI').value('');
                    widget.getField('DTVALFIN').reload();
                    widget.getField('DTVALINI').reload();
                }
                General.saveCrud(widget);
            } else if(inicial == "Invalid date" && final != "Invalid date"){
                    ScreenService.showMessage("A validade inicial deve ser preenchida.");
            } else if(final == "Invalid date" && inicial != "Invalid date"){
                ScreenService.showMessage("A validade final deve ser preenchida.");
            } else {
                General.saveCrud(widget);
            }
        }
    };
    
    this.openPopupTabpreclie = function(){
        var wdgPopup = templateManager.container.getWidget('popupFiltroTabpreclie');
        var cliente = wdgPopup.getField('NMRAZSOCCLIE').value();
        if(cliente == undefined || cliente == ""){
            ScreenService.openPopup(wdgPopup);
        }else{
            return 0;
        }
    };
    
    this.openPopupTabpreclieAction = function(){
        var wdgPopup = templateManager.container.getWidget('popupFiltroTabpreclie');
        ScreenService.openPopup(wdgPopup);
    };

    this.setDataSourceFilterTabpreclie = function(widget){
        if(widget.isValid()){
            widget.isVisible = false;
            var wdgPrecoPorCliente =  templateManager.container.getWidget('wdgPrecoPorCliente');
            ScreenService.closePopup(widget);
            wdgPrecoPorCliente.dataSourceFilter.push({
                name: "CDCLIENTE",
                operator: "=",
                value: widget.currentRow.CDCLIENTE
            });
            wdgPrecoPorCliente.reload();
        }
    };
    
     this.paramValue = function(){
        var widgetListaItemPreBase = templateManager.container.getWidget('listaItemPreBase');
        General.callRestEngine('ped#/crud/parampedido', "FilterData", [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function (sucesso) {
            var casaDeciUni = sucesso.dataset.parampedido[0].NRCASADECVRUNIT;
            widgetListaItemPreBase.getField('VRITEPREBASE').mask = 
            {
                type: "viewFloat",
                params:{
                precision: casaDeciUni ,
                thousands: ".",
                decimal: ",",
                allowNegative: false
                }
            };
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped02300_preco_base_Controller', Ped02300_preco_base_Controller);
});